<#if ((view.getPSDataEntity()??) && (view.hasPSControl('searchform'))) >
    <#assign de=view.getPSDataEntity()>
    <#assign form=view.getPSControl('searchform')>
    /**
     * 搜索表单属性值发生变化
     * 
     * @param {string} fieldname 
     * @param {*} field 
     * @param {*} value 
     * @memberof ${view.codeName}ComponentBase
     */
    public onSearchFormFieldChanged(fieldname: string, field: any, value: any): void {
        let form = this.getSearchForm();

        <#list searchform_fdlogics as fdlogic>
            ${fdlogic}  
        </#list>

        <#if form.getPSDEFormItems()??>
        <#list form.getPSDEFormItems() as formitem>
        <#if formitem.getPSDEFormItemUpdate()??>
        if (Object.is(fieldname, '${formitem.name}')) {
            form.updateFormItems('${formitem.getPSDEFormItemUpdate().codeName}');
        }
        </#if>
        </#list>
        </#if>

    }

    /**
     * 表单项值检测
     *
     * @param {string} fieldname
     * @param {string} value
     * @memberof ${view.codeName}ComponentBase
     */
    public onSearchFormFieldValueCheck(name: string, value: string): void {
        const form = this.getSearchForm();
        <#list searchform_vrlogics as vrlogic>
        
        ${vrlogic}
        </#list>
    }
    </#if>
     
    /**
     * 获取新建视图
     * 
     * @param {any} arg 
     * @returns {*} 
     * @memberof ${view.codeName}ComponentBase
     */
    public getNewDataView(params: any): any {
        if (!params) {
            params={};
        }
        let newmode = params.srfnewmode;
        if (!newmode) {
            newmode = '';
        }
        <#list view.getAppViewRefModes() as viewref>
        <#if (viewref?index_of("NEWDATA:")==0)>
        <#assign newdataview=view.getRefPSAppView(viewref,true) >
        <#assign newdataviewref=view.getPSAppViewRef(viewref,true) >
        if (Object.is(newmode, '${viewref?substring(8)}')){
            return { openMode:'${newdataview.getOpenMode(newdataviewref)}', className:'${newdataview.codeName}', viewParam:params };
        }
        </#if>
        </#list>
        
        <#if view.getRefPSAppView("NEWDATA",true)??>        
        <#assign newdataview=view.getRefPSAppView("NEWDATA",true) >
        <#assign newdataviewref=view.getPSAppViewRef("NEWDATA",true) >
        if (true) {
      	    let view = { openMode:'${newdataview.getOpenMode(newdataviewref)}', className:'${newdataview.codeName}', viewParam:params };
      	    return view;
        }
        </#if>
    }

    /**
     * 获取编辑视图
     * 
     * @param {any} arg 
     * @returns {*} 
     * @memberof ${view.codeName}ComponentBase
     */
    public getEditDataView(params: any): any {
        if (!params) {
            params={};
        }
           
        let list = [params.srfeditmode2,params.srfeditmode];
        for(let i=0;i<2;i++){
            let editmode = list[i];
            if (!editmode) {
                continue;
            }
            <#list view.getAppViewRefModes() as viewref>
            <#if (viewref?index_of("EDITDATA:")==0)>
            <#if view.getRefPSAppView(viewref,true)??>
            <#assign editdataview=view.getRefPSAppView(viewref,true) >
            <#assign editdataviewref=view.getPSAppViewRef(viewref,true) >
            if (Object.is(editmode, '${viewref?substring(9)}')) {
                return { openMode:'${editdataview.getOpenMode(editdataviewref)}',<#if editdataview.isRedirectView()> redirect: true, redirectUrl: '/${app.getAppFolder()}/${editdataview.getPSAppModule().codeName}/${editdataview.codeName}.do',</#if><#if !(editdataview.isRedirectView())> className:'${editdataview.codeName}',</#if> viewParam:params };
            }
            </#if>
            </#if>
            </#list>
        }

        <#if view.getRefPSAppView("EDITDATA",true)??>        
        <#assign editdataview=view.getRefPSAppView("EDITDATA",true) >
        <#assign editdataviewref=view.getPSAppViewRef("EDITDATA",true) >
        if (true) {
            params.srfeditmode = undefined;
            return { openMode:'${editdataview.getOpenMode(editdataviewref)}',<#if editdataview.isRedirectView()> redirect: true, redirectUrl: '/${app.getAppFolder()}/${editdataview.getPSAppModule().codeName}/${editdataview.codeName}.do',</#if><#if !(editdataview.isRedirectView())> className:'${editdataview.codeName}',</#if> viewParam:params };
        }
        </#if>
    }
    <#--  视图获取新建向导视图  -->
    <#if view.getRefPSAppView("NEWDATAWIZARD",true)??>
    <#assign newdatawizardview=view.getRefPSAppView("NEWDATAWIZARD",true) >
    <#assign newdatawizardviewref=view.getPSAppViewRef("NEWDATAWIZARD",true) >

    /**
     * 获取新建向导视图
     * 
     * @param {any} arg 
     * @returns {*} 
     * @memberof ${view.codeName}ComponentBase
     */
	public getNewDataWizardView(params): any {
        if (!params) {
            params = {};
        }
        let view = { modal:true, className:'${newdatawizardview.codeName}', viewParam:params };

	    return view;
    }
    </#if>
    <#--  视图支持批量添加  -->
    <#if (view.isEnableBatchAdd())>

    /**
     * 支持批量添加
     * 
     * @returns {boolean} 
     * @memberof ${view.codeName}ComponentBase
     */
    public isEnableBatchAdd(): boolean {
        return true;
    }
    
    /**
     * 获取多选视图
     *
     * @param {*} [arg={}]
     * @returns {*}
     * @memberof ${view.codeName}ComponentBase
     */
    public getMPickupView(arg: any = {}): any {
        if(!arg) {
            arg={};
        }
  
        const parentMode = this.getParentMode();
        Object.assign(arg, parentMode);
        let tempMode = this.getMDCtrl().tempMode;
        if(!tempMode) {
            tempMode = false;
        }
             
        <#assign de = view.getPSDataEntity()>
        <#assign dernn = de.getPSDERNN()>
        <#assign der1n = dernn.getFirstPSDER1N()>
        <#assign der1n2 = dernn.getSecondPSDER1N()>
        if (Object.is(arg.srfder1nid, '${der1n.name}')) {
            <#if view.getRefPSAppView("MPICKUPVIEW:"+der1n2.codeName,true)??>    
            <#assign mpickupview = view.getRefPSAppView("MPICKUPVIEW:"+der1n2.codeName,true) >
            <#assign mpickupviewref = view.getPSAppViewRef("MPICKUPVIEW:"+der1n2.codeName,true) >
            <#if (der1n2.getTempDataOrder() lt 0)>
            arg.srftempmode = false;
            <#else>
            arg.srftempmode = tempMode;
            </#if>
            const view = { modal: true, className: '${mpickupview.codeName}', viewParam: arg };
            return view;
        </#if> 
        }       
  
        <#assign der1n2 = dernn.getFirstPSDER1N()>
        <#assign der1n = dernn.getSecondPSDER1N()>   
        if (Object.is(arg.srfder1nid, '${der1n.name}')) {
            <#if view.getRefPSAppView("MPICKUPVIEW:"+der1n2.codeName,true)??>    
            <#assign mpickupview = view.getRefPSAppView("MPICKUPVIEW:"+der1n2.codeName,true) >
            <#assign mpickupviewref = view.getPSAppViewRef("MPICKUPVIEW:"+der1n2.codeName,true) >
            <#if (der1n2.getTempDataOrder() lt 0)>
            arg.srftempmode = false;
            <#else>
            arg.srftempmode = tempMode;
            </#if>
            const view = { modal: true, className: '${mpickupview.codeName}', viewParam: arg };
            return view;
        </#if> 
        }
        return undefined;
     }
    </#if>
    <#--  视图只支持批量添加  -->
    <#if (view.isBatchAddOnly())>

    /**
     * 只支持批量添加
     * 
     * @returns {boolean} 
     * @memberof ${view.codeName}ComponentBase
     */
	public isBatchAddOnly(): boolean {
        return true;
    }
    </#if>
    <#if (view.isEnablePrint())>

	public getPrintDataView(params:any): any {
    <#if view.getPSDEPrint()??>
        if (true) {
            params['srfprintid']='${view.getPSDEPrint().id}';
            let view: any = {viewParam:params};
            return view;
        }
    </#if>
    }
    </#if>
    <#--  视图是否默认加载  -->
    <#if (!view.isLoadDefault())>

    /**
     * 是否默认加载
     * 
     * @returns {boolean} 
     * @memberof ${view.codeName}ComponentBase
     */
    public isLoadDefault(): boolean {
        return false;
    }
    </#if>
    <#--  视图是否支持快速搜索  -->
    <#if (!view.isEnableQuickSearch())>

    /**
     * 是否支持快速搜索
     * 
     * @returns {boolean} 
     * @memberof ${view.codeName}ComponentBase
     */
    public isEnableQuickSearch(): boolean {
        return false;
    }
    </#if>
    <#--  是否支持快捷搜索  -->
    <#if view.isEnableQuickSearch()>
    <#--  处理快捷搜索字段  -->
    <#if view.isPSDEView()>
    <#assign iDataEntity = view.getDataEntity()> 
    
    /**
     * 注册实体支持快速搜索字段
     * 
     * @memberof ${view.codeName}ComponentBase
     */
    public regQuickSearchDEFileds(): void {
        <#list iDataEntity.getDEFields() as iDEField>
        <#if iDEField.isEnableQuickSearch()>
        this.$quickSearchEntityDEFields.push({ id: '${iDEField.getId()}', name: '${iDEField.getName()?lower_case}', logicname: '${iDEField.getLogicName()}', datatype: '${iDEField.getDataType()?lower_case}' });
        </#if>
        </#list>
    }
    </#if>
    </#if>