import { Component<#if view.isDynamicView() == true>, Renderer2, ComponentFactoryResolver</#if> } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { LocationStrategy } from '@angular/common';
import { NzModalService, NzModalSubject, NzNotificationService } from 'ng-zorro-antd';

import { IBizHttp} from '@ibizsys/util/IBizHttp';
import { IBizNotification } from '@ibizsys/util/IBizNotification';
import { IBizAppService } from '@ibizsys/IBizAppService';
<#if view.isDynamicView() == true>
import { IBizDynamicViewModalService } from '@ibizsys/dynamic-components/ibiz-dynamic-view-modal.service';
</#if>
import { MenuService } from '@delon/theme';


<#list modalviews as modalview>
import { ${modalview.codeName}ModalService } from 'app/pages/${ngfilename('${modalview.getPSAppModule().codeName}')}/${ngfilename('${modalview.codeName}')}/${ngfilename('${modalview.codeName}')}-modalservice';
</#list>

import { ${view.codeName}ComponentBase } from './${ngfilename('${view.codeName}')}.base';

@Component({
  selector: 'app-${ngfilename('${view.codeName}')}',
  templateUrl: './${ngfilename('${view.codeName}')}.html',
  styleUrls: [ './${ngfilename('${view.codeName}')}.less' ],
})

/**
 * 发布视图控制器对象，开发扩展使用
 * 
 * @export
 * @class ${view.codeName}Component
 * @extends {${view.codeName}ComponentBase}
 */
export class ${view.codeName}Component extends ${view.codeName}ComponentBase {
    constructor(
        private http: IBizHttp,
        private routeActive: ActivatedRoute,
        private route: Router,
        private location: LocationStrategy,
        private notification: IBizNotification,
        private modal: NzModalService,
        private modalSubject: NzModalSubject,
        private menuService: MenuService,
        private ibizAppService: IBizAppService,
<#if view.isDynamicView() == true>
        private ibizDynamicViewModalService: IBizDynamicViewModalService,
        private renderer2: Renderer2,
        private resolver: ComponentFactoryResolver,
</#if>
        <#list modalviews as modalview>
        ${modalview.codeName}ModalService: ${modalview.codeName}ModalService,
        </#list>
    ) {
        super({
            url: '/${app.getAppFolder()}/${view.getPSAppModule().codeName}/${view.codeName}.do',
            route: route,
            routeActive: routeActive,
            location: location,
            modal: modal,
            modalSubject: modalSubject,
            notification: notification,
            http: http,
            menuService: menuService,
            ibizAppService: ibizAppService,
<#if view.isDynamicView() == true>
            ibizDynamicViewModalService: ibizDynamicViewModalService,
            resolver: resolver,
            renderer2: renderer2,
</#if>
            <#list modalviews as modalview>
            ${modalview.codeName}ModalService: ${modalview.codeName}ModalService,
            </#list>
        });
    }

}