<#if modalviews??>
    /**
     * 获取视图模态框服务对象
     * 
     * @param {string} classname 视图名称
     * @returns {*} 
     * @memberof ${view.codeName}ComponentBase
     */
    public getModalService(classname: string): any {
        <#list modalviews as modalview >
        
        if (Object.is(classname, '${modalview.codeName}')) {
            return this.ibiz${modalview.codeName}ModalService;
        }
        </#list>

        return undefined;
    }
    </#if>

    <#if view.getPSSysCounterRefs()??>
    /**
     * 注册计数器
     * 
     * @memberof ${view.codeName}ComponentBase
     */
    public regUICounters(): void {
        <#list view.getPSSysCounterRefs() as syscounterref>
        <#assign syscounter=syscounterref.getPSSysCounter()>
        const ${syscounter.getCodeName()} = new IBizUICounterService({
            viewController: this, 
            name: '${syscounter.getCodeName()}', 
            counterId: '${syscounter.id}', 
            tag: '${syscounterref.tag}', 
            counterParam: ${syscounterref.getRefMode().toString()}, 
            timer: ${syscounter.timer?c},
            url: '/${app.getAppFolder()}/${view.getPSAppModule().codeName}/${view.codeName}.do',
            notification: this.$notification,
        });
        this.regUICounter('${syscounter.getCodeName()}', ${syscounter.getCodeName()});

        </#list>
    }
    </#if>

    /**
     * 注册代码表
     * 
     * @memberof ${view.codeName}ComponentBase
     */
    public regCodeLists(): void {
        <#list view.getRelatedPSCodeList(false) as codelist>
        <#if codelist.getCodeListType()=='STATIC'>
        
            /*${codelist.name}*/
            this.regCodeList(new IBizCodeList({id: '${srfparamname('${sys.codeName}')}_${codelist.codeName}',datas:[<#if codelist.getPSCodeItems()??><#list codelist.getPSCodeItems() as codeitem><#if (codeitem_index>0)>,</#if>{text:'${codeitem.text}',value:'${codeitem.value}',realtext:'${codeitem.realText}'<#if codeitem.getParentValue()??>,parentvalue='${codeitem.getParentValue()}'</#if><#if codeitem.getColor()??>,color:'${codeitem.getColor()}'</#if><#if codeitem.getTextCls()??>,textcls:'${codeitem.getTextCls()}'</#if><#if codeitem.getIconCls()??>,iconcls:'${codeitem.getIconCls()}'</#if>}</#list></#if>]}));
        </#if>
        </#list>
    }

    /**
     * 获取实体名称
     * 
     * @returns {string} 
     * @memberof ${view.codeName}ComponentBase
     */
    public getDEName(): string {
        return '<#if view.isPSDEView()><#if view.getPSDataEntity()??>${view.getPSDataEntity().getName()}</#if></#if>';
    }
}